require 'osx/cocoa'
require 'test-strings/copy-util'

MAC_OS_ROMAN_ENCODING=30
UTF8_ENCODING=4

def copy(string)
  copy_with_encoding(string, MAC_OS_ROMAN_ENCODING)
  true
end

#Example: unicopy %w{ 03b4 03d4 03a6 }
def unicopy(hex_string_array)
  assert_names_of_acceptable_length(hex_string_array)
  copy_with_encoding(utf8(hex_string_array), UTF8_ENCODING)
  true
end

# Utilities

def utf8(hex_string_array)
  number_array = hex_string_array.collect do | hex_name |
    hex_name.to_i(16)
  end
  number_array.pack("U*")
end

def copy_with_encoding(string, encoding)
  data = OSX::NSData.dataWithRubyString(string)
  ns_string = OSX::NSString.alloc.initWithData(data, :encoding, encoding)
  pb = OSX::NSPasteboard.generalPasteboard
  pb.declareTypes(["NSStringPboardType"], :owner, nil)
  pb.setString(ns_string, :forType, "NSStringPboardType")
end

