if /darwin/ =~ RUBY_PLATFORM
  require 'test/unit'
  require 'test-strings'

  class  MacOSXCopyTests < Test::Unit::TestCase

    def test_copy
      # Pick a name unlikely to already be on the clipboard.
      string = "mac clipboard test " + rand(1000000).to_s
      
      copy(string)
      assert_equal(string, `pbpaste`)
    end


    def test_unicopy
      characters = %w{16e2 42 3a6}
      unicopy(characters)

      # Read back and compare to original.
      expected = characters.collect { | c | c.to_i(16) }
      
      pb = OSX::NSPasteboard.generalPasteboard
      ns_string = pb.stringForType("NSStringPboardType")
      actual = (0...ns_string.length).collect { | i |
        ns_string.characterAtIndex(i)
      }
      assert_equal(expected, actual)
    end

    # Utilities

    def test_utf8_converts_arrays_of_hex_names_to_packed_utf8
      assert_equal("\001", utf8(["0001"]))
      assert_equal("\316\264=\177\316\262", utf8(%w{03b4 003d 007f 03b2}))
    end
  end

end

