module Test
  module Unit
    module Assertions

      # Like assert_raises, except check for expected message as well.
      def assert_raises_with_message(expected_exception, expected_message)
        begin
          yield
        rescue expected_exception => exception
          assert_equal(expected_message, exception.message)
        rescue => exception
          fail("Expected #{expected_exception}; got #{exception}")
        else
          fail("Expected #{expected_exception}; got nothing.")
        end
      end
    end
  end
end
